/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Jabber
 *  Copyright (C) 1998-1999 The Jabber Team http://jabber.org/
 */

#include "etherxd.h"

/* internal lookup table for matching hosts/namespaces to delivery points */

edb db(int cmd, char *host, char *namespace)
{
    static edb d = NULL;
    edb next, prev;

    if(host == NULL || namespace == NULL);

    switch(cmd)
    {
        case CMD_SET:
            jdebug(ZONE,"db(SET,%s,%s)",host,namespace);
            db(CMD_DEL,host,namespace);
            next = malloc(sizeof(_edb));
            next->host = j_strdup(host);
            next->namespace = j_strdup(namespace);
            next->t = NULL;
            next->dso_handler = NULL;
            next->next = d;
            next->count = 0;
            d = next;
            return next;
            break;
        case CMD_GET:
            jdebug(ZONE,"db(GET,%s,%s)",host,namespace);
            next = d;
            while(next != NULL)
            {
                if(j_strcmp(host,next->host) == 0 && j_strcmp(namespace,next->namespace) == 0)
                    return next;
                next = next->next;
            }
            break;
        case CMD_DEL:
            jdebug(ZONE,"db(DEL,%s,%s)",host,namespace);
            prev = next = d;
            while(next != NULL)
            {
                if(j_strcmp(host,next->host) == 0 && j_strcmp(namespace,next->namespace) == 0)
                {
                    if(next == d)
                        d = next->next;
                    else
                        prev->next = next->next;
                    free(next->host);
                    free(next->namespace);
                    free(next);
                    return NULL;
                }
                prev = next;
                next = next->next;
            }

    }
    return NULL;
}
